<?php

namespace extension\shipping_menu\common;

// we extend the standard Opencart menu class
class ControllerColumnLeft extends \Opencart\Admin\Controller\Common\ColumnLeft {
    
    // this trait adds functions for disabling render of the parent class
    // and getting the render information from the parent class call 
    use \extension\ka_extensions\TraitController;

    public function index(): string {

        // disable template generation
        $this->disableRender();

        // let the parent function do all necessary preparations
        parent::index();

        // enable template generation
        $this->enableRender();
        
        // here we get the data array() and the template name
        // that were passed to the last view call by the parent function
        //
        $data     = $this->getRenderData();
        $template = $this->getRenderTemplate();

		// check the data (just in case)
		// 
		if (empty($data)) {
			return '';
		}
		
		//
        // prepare our menu item
        //

        // take the menu name from an existing language file
		$this->load->language('extension/shipping');
		
        // create the menu similar to default ones
        $item = [
            'id'       => 'menu-shipping-list',
            'icon'    => 'fas fa-shipping-fast',
            'name'    => $this->language->get('heading_title'),
            'href'     => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping'),
            'children' => []
        ];

        // put our new menu item to the existing menu array
        array_push($data['menus'], $item);

        // ask Opencart to render the template this time
		return $this->load->view($template, $data);
    }
}